PGBENCH(1)

NAME
pgbench - run a benchmark test on PostgreSQL

SYNOPSIS

pgbench -i [option...] [dbname]

pgbench [option...] [dbname]

DESCRIPTION

pgbench is a simple program for running benchmark tests on PostgreSQL. It runs the same sequence of SQL commands over and over, possibly in multiple concurrent database sessions, and then calculates the average transaction rate (transactions per second). By default, pgbench tests a scenario that is loosely based on TPC-B, involving five SELECT, UPDATE, and INSERT commands per transaction. However, it is easy to test other cases by writing your own transaction script files.

Typical output from pgbench looks like:

    transaction type: TPC-B (sort of)
    scaling factor: 10
    query mode: simple
    number of clients: 10
    number of threads: 1
    number of transactions per client: 1000
    number of transactions actually processed: 10000/10000
    tps = 85.184871 (including connections establishing)
    tps = 85.296346 (excluding connections establishing)

The first six lines report some of the most important parameter settings. The next line reports the number of transactions completed and intended (the latter being just the product of number of clients and number of transactions per client); these will be equal unless the run failed before completion. (In -T mode, only the actual number of transactions is printed.) The last two lines report the number of transactions per second, figured with and without counting the time to start database sessions.

The default TPC-B-like transaction test requires specific tables to be set up beforehand. pgbench should be invoked with the -i (initialize) option to create and populate these tables. (When you are testing a custom script, you don't need this step, but will instead need to do whatever setup your test needs.) Initialization looks like:

    pgbench -i [ other-options ] dbname

where dbname is the name of the already-created database to test in. (You may also need -h, -p, and/or -U options to specify how to connect to the database server.)

    Caution

    pgbench -i creates four tables pgbench_accounts, pgbench_branches, pgbench_history, and pgbench_tellers, destroying any existing tables of these names. Be very careful to use another database if you have tables having these names!

At the default “scale factor” of 1, the tables initially contain this many rows:

    table                   # of rows
    ---------------------------------
    pgbench_branches        1
    pgbench_tellers         10
    pgbench_accounts        100000
    pgbench_history         0

You can (and, for most purposes, probably should) increase the number of rows by using the -s (scale factor) option. The -F (fillfactor) option might also be used at this point.

Once you have done the necessary setup, you can run your benchmark with a command that doesn't include -i, that is

    pgbench [ options ] dbname

In nearly all cases, you'll need some options to make a useful test. The most important options are -c (number of clients), -t (number of transactions), -T (time limit), and -f (specify a custom script file). See below for a full list.

OPTIONS

The following is divided into three subsections: Different options are used during database initialization and while running benchmarks, some options are useful in both cases.

  Initialization Options

pgbench accepts the following command-line initialization arguments:

-i
--initialize
    Required to invoke initialization mode.

-F fillfactor
--fillfactor=fillfactor
    Create the pgbench_accounts, pgbench_tellers and pgbench_branches tables with the given fillfactor. Default is 100.

-n
--no-vacuum
    Perform no vacuuming after initialization.

-q
--quiet
    Switch logging to quiet mode, producing only one progress message per 5 seconds. The default logging prints one message each 100000 rows, which often outputs many lines per second (especially on good hardware).

-s scale_factor
--scale=scale_factor
    Multiply the number of rows generated by the scale factor. For example, -s 100 will create 10,000,000 rows in the pgbench_accounts table. Default is 1. When the scale is 20,000 or larger, the columns used to hold account identifiers (aid columns) will switch to using larger integers (bigint), in order to be big enough to hold the range of account identifiers.

--foreign-keys
    Create foreign key constraints between the standard tables.

--index-tablespace=index_tablespace
    Create indexes in the specified tablespace, rather than the default tablespace.

--tablespace=tablespace
    Create tables in the specified tablespace, rather than the default tablespace.

--unlogged-tables
    Create all tables as unlogged tables, rather than permanent tables.

  Benchmarking Options

pgbench accepts the following command-line benchmarking arguments:

-c clients
--client=clients
    Number of clients simulated, that is, number of concurrent database sessions. Default is 1.

-C
--connect
    Establish a new connection for each transaction, rather than doing it just once per client session. This is useful to measure the connection overhead.

-d
--debug
    Print debugging output.

-D varname=value
--define=varname=value
    Define a variable for use by a custom script (see below). Multiple -D options are allowed.

-f filename
--file=filename
    Read transaction script from filename. See below for details. -N, -S, and -f are mutually exclusive.

-j threads
--jobs=threads
    Number of worker threads within pgbench. Using more than one thread can be helpful on multi-CPU machines. The number of clients must be a multiple of the number of threads, since each thread is given the same number of client sessions to manage. Default is 1.

-l
--log
    Write the time taken by each transaction to a log file. See below for details.

-L limit
--latency-limit=limit
    Transaction which last more than limit milliseconds are counted and reported separately, as late.

    When throttling is used (--rate=...), transactions that lag behind schedule by more than limit ms, and thus have no hope of meeting the latency limit, are not sent to the server at all. They are counted and reported separately as skipped.

-M querymode
--protocol=querymode
    Protocol to use for submitting queries to the server:

        • simple: use simple query protocol.

        • extended: use extended query protocol.

        • prepared: use extended query protocol with prepared statements.

    The default is simple query protocol. (See Chapter 50, Frontend/Backend Protocol, in the documentation for more information.)

-n
--no-vacuum
    Perform no vacuuming before running the test. This option is necessary if you are running a custom test scenario that does not include the standard tables pgbench_accounts, pgbench_branches, pgbench_history, and pgbench_tellers.

-N
--skip-some-updates
    Do not update pgbench_tellers and pgbench_branches. This will avoid update contention on these tables, but it makes the test case even less like TPC-B.

-P sec
--progress=sec
    Show progress report every sec seconds. The report includes the time since the beginning of the run, the tps since the last report, and the transaction latency average and standard deviation since the last report. Under throttling (-R), the latency is computed with respect to the transaction scheduled start time, not the actual transaction beginning time, thus it also includes the average schedule lag time.

-r
--report-latencies
    Report the average per-statement latency (execution time from the perspective of the client) of each command after the benchmark finishes. See below for details.

-R rate
--rate=rate
    Execute transactions targeting the specified rate instead of running as fast as possible (the default). The rate is given in transactions per second. If the targeted rate is above the maximum possible rate, the rate limit won't impact the results.

    The rate is targeted by starting transactions along a Poisson-distributed schedule time line. The expected start time schedule moves forward based on when the client first started, not when the previous transaction ended. That approach means that when transactions go past their original scheduled end time, it is possible for later ones to catch up again.

    When throttling is active, the transaction latency reported at the end of the run is calculated from the scheduled start times, so it includes the time each transaction had to wait for the previous transaction to finish. The wait time is called the schedule lag time, and its average and maximum are also reported separately. The transaction latency with respect to the actual transaction start time, i.e. the time spent executing the transaction in the database, can be computed by subtracting the schedule lag time from the reported latency.

    If --latency-limit is used together with --rate, a transaction can lag behind so much that it is already over the latency limit when the previous transaction ends, because the latency is calculated from the scheduled start time. Such transactions are not sent to the server, but are skipped altogether and counted separately.

    A high schedule lag time is an indication that the system cannot process transactions at the specified rate, with the chosen number of clients and threads. When the average transaction execution time is longer than the scheduled interval between each transaction, each successive transaction will fall further behind, and the schedule lag time will keep increasing the longer the test run is. When that happens, you will have to reduce the specified transaction rate.

-s scale_factor
--scale=scale_factor
    Report the specified scale factor in pgbench's output. With the built-in tests, this is not necessary; the correct scale factor will be detected by counting the number of rows in the pgbench_branches table. However, when testing custom benchmarks (-f option), the scale factor will be reported as 1 unless this option is used.

-S
--select-only
    Perform select-only transactions instead of TPC-B-like test.

-t transactions
--transactions=transactions
    Number of transactions each client runs. Default is 10.

-T seconds
--time=seconds
    Run the test for this many seconds, rather than a fixed number of transactions per client. -t and -T are mutually exclusive.

-v
--vacuum-all
    Vacuum all four standard tables before running the test. With neither -n nor -v, pgbench will vacuum the pgbench_tellers and pgbench_branches tables, and will truncate pgbench_history.

--aggregate-interval=seconds
    Length of aggregation interval (in seconds). May be used only together with -l - with this option, the log contains per-interval summary (number of transactions, min/max latency and two additional fields useful for variance estimation).

    This option is not currently supported on Windows.

--sampling-rate=rate
    Sampling rate, used when writing data into the log, to reduce the amount of log generated. If this option is given, only the specified fraction of transactions are logged. 1.0 means all transactions will be logged, 0.05 means only 5% of the transactions will be logged.

    Remember to take the sampling rate into account when processing the log file. For example, when computing tps values, you need to multiply the numbers accordingly (e.g. with 0.01 sample rate, you'll only get 1/100 of the actual tps).

  Common Options

pgbench accepts the following command-line common arguments:

-h hostname
--host=hostname
    The database server's host name

-p port
--port=port
    The database server's port number

-U login
--username=login
    The user name to connect as

-V
--version
    Print the pgbench version and exit.

-?
--help
    Show help about pgbench command line arguments, and exit.

NOTES

  What is the “Transaction” Actually Performed in pgbench?

The default transaction script issues seven commands per transaction:

    1. BEGIN;

    2. UPDATE pgbench_accounts SET abalance = abalance + :delta WHERE aid = :aid;

    3. SELECT abalance FROM pgbench_accounts WHERE aid = :aid;

    4. UPDATE pgbench_tellers SET tbalance = tbalance + :delta WHERE tid = :tid;

    5. UPDATE pgbench_branches SET bbalance = bbalance + :delta WHERE bid = :bid;

    6. INSERT INTO pgbench_history (tid, bid, aid, delta, mtime) VALUES (:tid, :bid, :aid, :delta, CURRENT_TIMESTAMP);

    7. END;

If you specify -N, steps 4 and 5 aren't included in the transaction. If you specify -S, only the SELECT is issued.

  Custom Scripts

pgbench has support for running custom benchmark scenarios by replacing the default transaction script (described above) with a transaction script read from a file (-f option). In this case a “transaction” counts as one execution of a script file. You can even specify multiple scripts (multiple -f options), in which case a random one of the scripts is chosen each time a client session starts a new transaction.

The format of a script file is one SQL command per line; multiline SQL commands are not supported. Empty lines and lines beginning with -- are ignored. Script file lines can also be “meta commands”, which are interpreted by pgbench itself, as described below.

There is a simple variable-substitution facility for script files. Variables can be set by the command-line -D option, explained above, or by the meta commands explained below. In addition to any variables preset by -D command-line options, there are a few variables that are preset automatically, listed in Table 221, “Automatic variables”. A value specified for these variables using -D takes precedence over the automatic presets. Once set, a variable's value can be inserted into a SQL command by writing :variablename. When running more than one client session, each session has its own set of variables.

Table 221. Automatic variables
Variable | Description
scale | current scale factor
client_id | unique number identifying the client session (starts from zero)

Script file meta commands begin with a backslash (\). Arguments to a meta command are separated by white space. These meta commands are supported:

\set varname expression
    Sets variable varname to an integer value calculated from expression. The expression may contain integer constants such as 5432, references to variables :variablename, and expressions composed of unary (-) or binary operators (+, -, *, /, %) with their usual associativity, and parentheses.

    Examples:

        \set ntellers 10 * :scale
        \set aid (1021 * :aid) % (100000 * :scale) + 1

\setrandom varname min max [ uniform | { gaussian | exponential } parameter ]
    Sets variable varname to a random integer value between the limits min and max inclusive. Each limit can be either an integer constant or a :variablename reference to a variable having an integer value.

    By default, or when uniform is specified, all values in the range are drawn with equal probability. Specifying gaussian or exponential options modifies this behavior; each requires a mandatory parameter which determines the precise shape of the distribution.

    For a Gaussian distribution, the interval is mapped onto a standard normal distribution (the classical bell-shaped Gaussian curve) truncated at -parameter on the left and +parameter on the right. Values in the middle of the interval are more likely to be drawn. To be precise, if PHI(x) is the cumulative distribution function of the standard normal distribution, with mean mu defined as (max + min) / 2.0, with

         f(x) = PHI(2.0 * parameter * (x - mu) / (max - min + 1)) /
                (2.0 * PHI(parameter) - 1.0)

    then value i between min and max inclusive is drawn with probability: f(i + 0.5) - f(i - 0.5). Intuitively, the larger parameter, the more frequently values close to the middle of the interval are drawn, and the less frequently values close to the min and max bounds. About 67% of values are drawn from the middle 1.0 / parameter, that is a relative 0.5 / parameter around the mean, and 95% in the middle 2.0 / parameter, that is a relative 1.0 / parameter around the mean; for instance, if parameter is 4.0, 67% of values are drawn from the middle quarter (1.0 / 4.0) of the interval (i.e. from 3.0 / 8.0 to 5.0 / 8.0) and 95% from the middle half (2.0 / 4.0) of the interval (second and third quartiles). The minimum parameter is 2.0 for performance of the Box-Muller transform.

    For an exponential distribution, parameter controls the distribution by truncating a quickly-decreasing exponential distribution at parameter, and then projecting onto integers between the bounds. To be precise, with

        f(x) = exp(-parameter * (x - min) / (max - min + 1)) / (1.0 - exp(-parameter))

    Then value i between min and max inclusive is drawn with probability: f(x) - f(x + 1). Intuitively, the larger parameter, the more frequently values close to min are accessed, and the less frequently values close to max are accessed. The closer to 0 parameter, the flatter (more uniform) the access distribution. A crude approximation of the distribution is that the most frequent 1% values in the range, close to min, are drawn parameter% of the time. parameter value must be strictly positive.

    Example:

        \setrandom aid 1 :naccounts gaussian 5.0

\sleep number [ us | ms | s ]
    Causes script execution to sleep for the specified duration in microseconds (us), milliseconds (ms) or seconds (s). If the unit is omitted then seconds are the default. number can be either an integer constant or a :variablename reference to a variable having an integer value.

    Example:

        \sleep 10 ms

\setshell varname command [ argument ... ]
    Sets variable varname to the result of the shell command command. The command must return an integer value through its standard output.

    argument can be either a text constant or a :variablename reference to a variable of any types. If you want to use argument starting with colons, you need to add an additional colon at the beginning of argument.

    Example:

        \setshell variable_to_be_assigned command literal_argument :variable ::literal_starting_with_colon

\shell command [ argument ... ]
    Same as \setshell, but the result is ignored.

    Example:

        \shell command literal_argument :variable ::literal_starting_with_colon

As an example, the full definition of the built-in TPC-B-like transaction is:

    \set nbranches :scale
    \set ntellers 10 * :scale
    \set naccounts 100000 * :scale
    \setrandom aid 1 :naccounts
    \setrandom bid 1 :nbranches
    \setrandom tid 1 :ntellers
    \setrandom delta -5000 5000
    BEGIN;
    UPDATE pgbench_accounts SET abalance = abalance + :delta WHERE aid = :aid;
    SELECT abalance FROM pgbench_accounts WHERE aid = :aid;
    UPDATE pgbench_tellers SET tbalance = tbalance + :delta WHERE tid = :tid;
    UPDATE pgbench_branches SET bbalance = bbalance + :delta WHERE bid = :bid;
    INSERT INTO pgbench_history (tid, bid, aid, delta, mtime) VALUES (:tid, :bid, :aid, :delta, CURRENT_TIMESTAMP);
    END;

This script allows each iteration of the transaction to reference different, randomly-chosen rows. (This example also shows why it's important for each client session to have its own variables — otherwise they'd not be independently touching different rows.)

  Per-Transaction Logging

With the -l option but without the --aggregate-interval, pgbench writes the time taken by each transaction to a log file. The log file will be named pgbench_log.nnn, where nnn is the PID of the pgbench process. If the -j option is 2 or higher, creating multiple worker threads, each will have its own log file. The first worker will use the same name for its log file as in the standard single worker case. The additional log files for the other workers will be named pgbench_log.nnn.mmm, where mmm is a sequential number for each worker starting with 1.

The format of the log is:

    client_id transaction_no time file_no time_epoch time_us [schedule_lag]

where time is the total elapsed transaction time in microseconds, file_no identifies which script file was used (useful when multiple scripts were specified with -f), and time_epoch/time_us are a Unix epoch format time stamp and an offset in microseconds (suitable for creating an ISO 8601 time stamp with fractional seconds) showing when the transaction completed. Field schedule_lag is the difference between the transaction's scheduled start time, and the time it actually started, in microseconds. It is only present when the --rate option is used. When both --rate and --latency-limit are used, the time for a skipped transaction will be reported as skipped.

Here is a snippet of the log file generated:

     0 199 2241 0 1175850568 995598
     0 200 2465 0 1175850568 998079
     0 201 2513 0 1175850569 608
     0 202 2038 0 1175850569 2663

Another example with --rate=100 and --latency-limit=5 (note the additional schedule_lag column):

     0 81 4621 0 1412881037 912698 3005
     0 82 6173 0 1412881037 914578 4304
     0 83 skipped 0 1412881037 914578 5217
     0 83 skipped 0 1412881037 914578 5099
     0 83 4722 0 1412881037 916203 3108
     0 84 4142 0 1412881037 918023 2333
     0 85 2465 0 1412881037 919759 740

In this example, transaction 82 was late, because its latency (6.173 ms) was over the 5 ms limit. The next two transactions were skipped, because they were already late before they were even started.

When running a long test on hardware that can handle a lot of transactions, the log files can become very large. The --sampling-rate option can be used to log only a random sample of transactions.

  Aggregated Logging

With the --aggregate-interval option, the logs use a bit different format:

    interval_start num_of_transactions latency_sum latency_2_sum min_latency max_latency [lag_sum lag_2_sum min_lag max_lag [skipped_transactions]]

where interval_start is the start of the interval (Unix epoch format time stamp), num_of_transactions is the number of transactions within the interval, latency_sum is a sum of latencies (so you can compute average latency easily). The following two fields are useful for variance estimation - latency_sum is a sum of latencies and latency_2_sum is a sum of 2nd powers of latencies. The last two fields are min_latency - a minimum latency within the interval, and max_latency - maximum latency within the interval. A transaction is counted into the interval when it was committed. The fields in the end, lag_sum, lag_2_sum, min_lag, and max_lag, are only present if the --rate option is used. The very last one, skipped_transactions, is only present if the option --latency-limit is present, too. They are calculated from the time each transaction had to wait for the previous one to finish, i.e. the difference between each transaction's scheduled start time and the time it actually started.

Here is example output:

    1345828501 5601 1542744 483552416 61 2573
    1345828503 7884 1979812 565806736 60 1479
    1345828505 7208 1979422 567277552 59 1391
    1345828507 7685 1980268 569784714 60 1398
    1345828509 7073 1979779 573489941 236 1411

Notice that while the plain (unaggregated) log file contains a reference to the custom script files, the aggregated log does not. Therefore if you need per script data, you need to aggregate the data on your own.

  Per-Statement Latencies

With the -r option, pgbench collects the elapsed transaction time of each statement executed by every client. It then reports an average of those values, referred to as the latency for each statement, after the benchmark has finished.

For the default script, the output will look similar to this:

    starting vacuum...end.
    transaction type: TPC-B (sort of)
    scaling factor: 1
    query mode: simple
    number of clients: 10
    number of threads: 1
    number of transactions per client: 1000
    number of transactions actually processed: 10000/10000
    tps = 618.764555 (including connections establishing)
    tps = 622.977698 (excluding connections establishing)
    statement latencies in milliseconds:
            0.004386        \set nbranches 1 * :scale
            0.001343        \set ntellers 10 * :scale
            0.001212        \set naccounts 100000 * :scale
            0.001310        \setrandom aid 1 :naccounts
            0.001073        \setrandom bid 1 :nbranches
            0.001005        \setrandom tid 1 :ntellers
            0.001078        \setrandom delta -5000 5000
            0.326152        BEGIN;
            0.603376        UPDATE pgbench_accounts SET abalance = abalance + :delta WHERE aid = :aid;
            0.454643        SELECT abalance FROM pgbench_accounts WHERE aid = :aid;
            5.528491        UPDATE pgbench_tellers SET tbalance = tbalance + :delta WHERE tid = :tid;
            7.335435        UPDATE pgbench_branches SET bbalance = bbalance + :delta WHERE bid = :bid;
            0.371851        INSERT INTO pgbench_history (tid, bid, aid, delta, mtime) VALUES (:tid, :bid, :aid, :delta, CURRENT_TIMESTAMP);
            1.212976        END;

If multiple script files are specified, the averages are reported separately for each script file.

Note that collecting the additional timing information needed for per-statement latency computation adds some overhead. This will slow average execution speed and lower the computed TPS. The amount of slowdown varies significantly depending on platform and hardware. Comparing average TPS values with and without latency reporting enabled is a good way to measure if the timing overhead is significant.

  Good Practices

It is very easy to use pgbench to produce completely meaningless numbers. Here are some guidelines to help you get useful results.

In the first place, never believe any test that runs for only a few seconds. Use the -t or -T option to make the run last at least a few minutes, so as to average out noise. In some cases you could need hours to get numbers that are reproducible. It's a good idea to try the test run a few times, to find out if your numbers are reproducible or not.

For the default TPC-B-like test scenario, the initialization scale factor (-s) should be at least as large as the largest number of clients you intend to test (-c); else you'll mostly be measuring update contention. There are only -s rows in the pgbench_branches table, and every transaction wants to update one of them, so -c values in excess of -s will undoubtedly result in lots of transactions blocked waiting for other transactions.

The default test scenario is also quite sensitive to how long it's been since the tables were initialized: accumulation of dead rows and dead space in the tables changes the results. To understand the results you must keep track of the total number of updates and when vacuuming happens. If autovacuum is enabled it can result in unpredictable changes in measured performance.

A limitation of pgbench is that it can itself become the bottleneck when trying to test a large number of client sessions. This can be alleviated by running pgbench on a different machine from the database server, although low network latency will be essential. It might even be useful to run several pgbench instances concurrently, on several client machines, against the same database server.